#!/usr/local/bin/perl 
require '../code/heald_lib.pl';

read_hash(FILENAME => '../code/dat/researchers.dat', HASH => \%desccode, 
			FIRSTKEY => 1, VALFIELD => 0, CASE => 'L');

## LEFTOVERS

#my $COUNTIES	=  '../code/counties2.dat';
my $COUNTIES	=  '../code/dat/counties2.dat';

sub read_counties2 {
	read_hash(FILENAME => $COUNTIES, HASH => \%chap, 
				FIRSTKEY => 2, VALFIELD => 1, CASE => 'U');
}

#&read_counties2;

%file_base = (
	1625 => "e1625",
	1725 => "e1725",
	1800 => "e1800",
	1850 => "e1850",
	9998 => "e1900",
	9999 => "eC19",
);

@break_years = sort keys %file_base;

%file_suf = (
	LAN => "_LAN",
	CHS => "_CHS",
	YKS => "_YKS",
	DBY => "_DNL",
	NTT => "_DNL",
	LIN => "_DNL",
);

%quarter = (
	Jan => Q1 , Feb => Q1 , Mar => Q1 ,
	Apr => Q2 , May => Q2 , Jun => Q2 ,
	Jul => Q3 , Aug => Q3 , Sep => Q3 ,
	Oct => Q4 , Nov => Q4 , Dec => Q4 ,
);

sub get_filename {
	my ($ct,$yr1) = @_;
	my ($year,$byear,$base_name,$suffix);
	($year,undef) = ($yr1 =~ /^(\d\d\d\d)/);
	@byears = @break_years;
	while (1) {
		$byear = shift(@byears);
		last if ($byear >= $year);
	}
	$base_name = $file_base{$byear};
	$suffix    = $file_suf{$ct};
	return ($base_name.$suffix.'.html');
}

## PAGE HEADERS AND FOOTERS

sub page_header {
	my ($title,$desc,$links) = @_;
	$desc ||= $title;
	$links ||= 'h';
	
	print {$OUTFILE} << "End_Of_HTML_Header";
<HTML>
<HEAD>
<TITLE>$title</TITLE>
<script>
var prev;
function highlight() {
	if (typeof(document.all)=='undefined') {return};
	if (typeof(document.all["tr"+prev]) != 'undefined') {
		document.all["tr"+prev].bgColor='white';
	}
	if (typeof(document.all["tr"+self.location.hash]) != 'undefined') {
		document.all["tr"+self.location.hash].bgColor='yellow';
	}
	prev = self.location.hash;
}
</script>
</HEAD>
<BODY BGCOLOR=#ffffff onload="highlight();self.focus()">
End_Of_HTML_Header

	print {$OUTFILE} "<table width=100% border=0><tr>";
	&logo;
	&rlinks($links,'head');
	print {$OUTFILE} "</tr></table>\n";
	print {$OUTFILE} "<HR color=#CC0000>\n";
	print {$OUTFILE} "<font face='arial' size=-1>\n<B>$desc</B>\n</font>";
	if ($do_az_bar) {&az_bar};
	&copytext;
	print {$OUTFILE} "<table border=0 cellspacing=0 width=100%>";
	print {$OUTFILE} "<font class=f2unbold face='times'>\n";
}

sub logo {
	print {$OUTFILE} "<td><font face='arial' size=5><b>HEALDS.ORG.UK</b></font></td>\n";
}

sub page_footer {
	my ($links,undef) = @_;
	print {$OUTFILE} << 'End_Of_LastMod';
</table>
<p>
<table width=100% border=0><tr>
<td><font class=f2unbold face="arial,helvetica,sans serif" size=2>
<script>document.write("Last modified: ",document.lastModified,"<BR>")</script>
Feedback: <a href="mailto:j.heald@ucl.ac.uk">j.heald@ucl.ac.uk</a>
 </font></td>
End_Of_LastMod

	&rlinks($links,'head');
	print {$OUTFILE} "</tr></table>\n";
	print {$OUTFILE} "</body></html>\n\n";
}


sub az_bar {
	print {$OUTFILE} << "End_Of_AZbar";
<P>
<center><font face="verdana, arial, helvetica" size="-1">
[
<a href='#A'>A</a>
<a href='#B'>B</a>
<a href='#C'>C</a>
<a href='#D'>D</a>
<a href='#E'>E</a>
<a href='#F'>F</a>
<a href='#G'>G</a>
<a href='#H'>H</a>
<a href='#I'>I</a>
<a href='#J'>J</a>
<a href='#K'>K</a>
<a href='#L'>L</a>
<a href='#M'>M</a>
<a href='#N'>N</a>
<a href='#O'>O</a>
<a href='#P'>P</a>
<a href='#Q'>Q</a>
<a href='#R'>R</a>
<a href='#S'>S</a>
<a href='#T'>T</a>
<a href='#U'>U</a>
<a href='#V'>V</a>
<a href='#W'>W</a>
<a href='#X'>X</a>
<a href='#Y'>Y</a>
<a href='#Z'>Z</a>
<a href='#--'>Ukn.</a>
]
</font></center></p>
End_Of_AZbar
}

#external variable: $file_prefix
sub az_bar2 {
	print {$OUTFILE} << "End_Of_AZbar2";
<tr><td colspan=20>
<center><font face="verdana, arial, helvetica" size="-1">
[
<a href='$file_prefix\uA.html'>A</a>
<a href='$file_prefix\uB.html'>B</a>
<a href='$file_prefix\uC.html'>C</a>
<a href='$file_prefix\uD.html'>D</a>
<a href='$file_prefix\uE.html'>E</a>
<a href='$file_prefix\uF.html'>F</a>
<a href='$file_prefix\uG.html'>G</a>
<a href='$file_prefix\uH.html'>H</a>
<a href='$file_prefix\uI.html'>I</a>
<a href='$file_prefix\uJ.html'>J</a>
<a href='$file_prefix\uK.html'>K</a>
<a href='$file_prefix\uL.html'>L</a>
<a href='$file_prefix\uM.html'>M</a>
<a href='$file_prefix\uN.html'>N</a>
<a href='$file_prefix\uO.html'>O</a>
<a href='$file_prefix\uP.html'>P</a>
<a href='$file_prefix\uQ.html'>Q</a>
<a href='$file_prefix\uR.html'>R</a>
<a href='$file_prefix\uS.html'>S</a>
<a href='$file_prefix\uT.html'>T</a>
<a href='$file_prefix\uU.html'>U</a>
<a href='$file_prefix\uV.html'>V</a>
<a href='$file_prefix\uW.html'>W</a>
<a href='$file_prefix\uX.html'>X</a>
<a href='$file_prefix\uY.html'>Y</a>
<a href='$file_prefix\uZ.html'>Z</a>
<a href='$file_prefix\uUkn.html'>Ukn</a>
]
</font></center></p>
</td></tr>
End_Of_AZbar2
}

sub copytext {
	print {$OUTFILE} << "End_Of_Copytext";
<font size= -1><p>
COPYRIGHT NOTE: The information on these pages is principally derived from
the LDS <a href="http://www.familysearch.org/Eng/Search/frameset_search.asp?PAGE=igi/search_IGI.asp">International Genealogical Index (IGI)</a>; 
the LDS <a href="http://www.familysearch.org/Eng/Search/frameset_search.asp?PAGE=af/search_AF.asp">Ancestral File</a>;
the <a href="$outdir../census/census.html">1851</a>, 
<a href="http://www.familysearch.org/Eng/Search/frameset_search.asp?PAGE=census/search_census.asp">1881</a> and 
<a href="http://www.census.pro.gov.uk/">1901</a>
UK Censuses;
the LDS <a href="http://www.ldscatalog.com/cgi-bin/ncommerce3/ProductDisplay?prrfnbr=5196950&prmenbr=1402&CGRY_NUM=1440461&RowStart=436661&LocCode=FH">British Vital Records CDs</a> (2nd edition); 
<a href="http://www.cheshirebmd.org.uk/">CheshireBMD</a>,
<a href="http://www.lancashirebmd.org.uk/">LancashireBMD</a>, and
<a href="http://www.yorkshirebmd.org.uk/">YorkshireBMD</a>;
the <a href="http://www.freebmd.org.uk/">FreeBMD</a> project;
and contributions from individual <a href="$outdir../researchers.html">researchers</a>.
It is presented here strictly for the purpose of noncommercial scholarship, 
in line with international standards of copyright Fair Use.
Do not reuse this material commercially, or in any way likely to upset the LDS or HMSO;
and do not reproduce it without this message.
<br>
Raw data &copy Crown Copyright / &copy LDS 1980-2001 / &copy others.
Analysis and arrangement &copy J.Heald 2001-2006.
<p>
Several of the pages on this site are quite large and may take some time to load; and even
once loaded, pages may take several seconds to format. You may find it much faster to download a zipfile of the whole site
from the home page, decompress it, and then browse it directly from your own hard drive. 

<p>Click <a href="$outdir../info.html"><i><b>i</b></i></a> for further 
information about 
<a href="$outdir../info.html#sources">sources</a>, 
<a href="$outdir../info.html#dates">dates</a>, 
<a href="$outdir../info.html#printing">printing tips</a>, 
and other general information.
<p>
<b>IMPORTANT NOTE:</b><br>
The standard of proof used to consolidate these listings is <b>current best guess</b> (<em>not</em> 'absolute cast-iron certainty') -- so do not necessarily trust every suggested link, eg between a birth and a subsequent marriage, or consolidation, eg between different census returns.  The listings have been mostly compiled from published indexes: you are strongly advised to check out wherever possible the original underlying documents, which may contain further information that could contradict the assumptions here.  
<p>
Also be very aware that the listings are <b>far from complete</b>.  There are many more Healds whose parishes have not yet been included in the IGI or VRI; many Healds lost or mistranscribed in both the 1881 and 1901 censuses; and many more still to transcribe at FreeBMD (<a href="http://www.freebmd.org.uk/progress.shtml">latest progress</a>).  Just because there is only one Heald listed in a given place with a given name at a particular date, it is <em>not</em> necessarily safe to assume that they must definitely be the person you are looking for.

<p>
If there is any information you can add or correct, please contact me at 
<a href='mailto:j.heald\@ucl.ac.uk'>j.heald\@ucl.ac.uk</a>.
<p>


</font>
End_Of_Copytext
}

## SECTION BREAKS

# Default section header
sub section_head {
	my ($text,$links,$sec_name) = @_;
	if (!$sec_name) {
		(undef, $sec_name) = $text=~ /^#\s*(--)?\s*([\w-]*)/;
	}
	#($sec_text, undef) = $child=~ /^#\s*(.*)/;
	print {$OUTFILE} "<td colspan=20>\n";
	print {$OUTFILE} "<table width=100% border=0 cellspacing=0><tr>";
	print {$OUTFILE} "<td><table border=0 cellspacing=0><td bgcolor=#66ffff>";
	print {$OUTFILE} '<font class=f2unbold face="verdana,arial,helvetica,sans serif" size=1>';
	if ($sec_name) {print {$OUTFILE} "<a name='$sec_name'>"};
	print {$OUTFILE} "$text";
	print {$OUTFILE} "</font></td></table></td>\n";
	&rlinks($links,'table',$sec_name);
	print {$OUTFILE} "</tr></table>\n";
	print {$OUTFILE} "</td>\n";
	$first_line = 1;
}

$section_linecount = 0;

sub new_section {
	#print {$OUTFILE} "<table border=0 cellspacing=0 width=100%>";
	#print {$OUTFILE} "<font class=f2unbold face='times'>\n";
}

sub end_section {
	#if ($section_linecount > 40) {
	#	print {$OUTFILE} "</table>\n";
		
	#	print {$OUTFILE} "<table border=0 cellspacing=0 width=100%>";
	#	print {$OUTFILE} "<font class=f2unbold face='times'>\n";
	#}
	#$section_linecount = 0;
}

## LINK BARS

{
$links_array=0;
my %link;

sub mk_links_array {	# can't initialise array until $outdir has been set up
	%link = (
		t => "<a href='#'>Top</a> / \n",
		i => "<b><i><a href='$outdir../info.html'>i</a></i></b> /\n",
		m => "<a href='$outdir../marriages.html'>Marriages</a> /\n",
		C => "<a href='$outdir../children.html'>Children</a> /\n",
		u => "<a href='$outdir../counties.html'>UK</a> /\n",
		h => "<a href='$outdir../index.html'>HOME</a>",
	);
	$links_array=1;
}

my %style = (
	head => "<font class=f2unbold face='arial,helvetica,sans serif' size=2>\n",
	table => "<font class=f2unbold face='verdana,arial,helvetica,sans serif' size=1>",
);

sub rlinks {
	my ($links_list,$links_style,$sec_name) = @_;
	$links_style ||= 'table';
	
	if (!$links_array) {&mk_links_array};
	print {$OUTFILE} '<td align=right>';
	print {$OUTFILE} $style{$links_style};
	my $l;
	foreach $l (split('',$links_list)) {
		if (($l eq 'e') && $earlier_link) {
			print {$OUTFILE} "<a href=$earlier_link>Earlier</a> / ";
		} elsif (($l eq 'l') && $later_link) {
			print {$OUTFILE} "<a href=$later_link>Later</a> / ";
		} elsif (($l eq 'E') && $earlier_fname) {
			print {$OUTFILE} "<a href='$earlier_fname#$sec_name'>Earlier</a> / ";
		} elsif (($l eq 'L') && $later_fname) {
			print {$OUTFILE} "<a href='$later_fname#$sec_name'>Later</a> / ";
		} else {
			print {$OUTFILE} $link{$l};
		}
	}
	print {$OUTFILE} '</td>';
}
}

## LINKS

sub hashcode{
	my $ch1;
	($ch1 = $child) =~ s/([\[|\]\/\<\>]|\&lt;|\&gt;)//g;
	my $fa1;
	($fa1 = $father) =~ s/([\[|\]\/\<\>]|\&lt;|\&gt;)//g;
	my $mo1;
	($mo1 = $mother) =~ s/([\[|\]\/\<\>]|\&lt;|\&gt;)//g;
	my $mon;
	$mon = $month;
	if ($mon =~ /^Q/) {$mon .= '_'};
	my $yr;
	($yr = $year) =~ s/-/_/;
	my $hc = substr($ch1,0,2).substr($fa1,0,2).substr($mo1,0,2)
			.substr($day,0,2).substr($mon,0,3).$yr
			.substr($chapman,0,3);
	$hc =~ s/[\s\.]/_/g;
	if ($month=~ /Abt|Bef/) {
		if ($lds =~ /CEN 1881 \w+(\d\d\d\d)/) {
			$hc .= "_$1";
		} elsif ($lds =~ /CEN 1881 \w+(\d\d\d)/) {
			$hc .= "_$1";
		} elsif ($lds =~ /CEN 1901 \w+_(\d+)/) {
			$hc .= "_$1";
		}
	}
	return($hc);
}

%lnk = (
	LAN => _LAN,
	CHS => _CHS,
	YKS => _YKS,
	DBY => _DNL,
	NTT => _DNL,
	LIN => _DNL,
);

%p_reg_file = (
	lan => lan,
	chs => chs,
	yks => yks,
	dby => dnl,
	ntt => dnl,
	lin => dnl,
);

sub link_url {
	my $hc = &hashcode;
	for ($year) {			# CASE stmt
		($_ < 1626) && ($lfile='e1625') && last;
		($_ < 1726) && ($lfile='e1725') && last;
		($_ < 1801) && ($lfile='e1800') && last;
		($_ < 1851) && ($lfile='e1850') && last;
		$lfile = 'e1900';
	}
	my $link_url="$lfile$lnk{$chapman}.html#$hc";
	return($link_url);
}

$CEN_DIR = "../census";
sub cen_url {
	my ($cen_year,$cen_ref) = @_;
	if (($cen_year != 1901) && ($cen_ref=~ /^[A-Z]{3,4}\d{4}/)){
		($cen_file,$cen_anchor,undef) = $cen_ref =~ /^([A-Z]*)([0-9][0-9_A-Za-z]*)/;
		$cen_file = lc($cen_file);
		if (($cen_year==1881)  || ($cen_year == 1861)) {
    			$cen_url = "$CEN_DIR/$cen_file$cen_year.html#$cen_anchor";
    		} else {
    			$cen_url = "$CEN_DIR/$cen_file$cen_year.html#$cen_file$cen_anchor";
    		}
    	} elsif ($cen_year == 1901) {
		($cen_file,$cen_anchor,undef) = $cen_ref =~ /^([A-Z]*)_([0-9][0-9_A-Za-z]*)/;
		$cen_file = lc($cen_file);
    		$cen_url = "$CEN_DIR/$cen_file$cen_year.html#$cen_anchor";
    	} else {
    		$cen_url = "$CEN_DIR/details$cen_year.html#$cen_ref";
    	}
	return ($cen_url);
}

## MAIN LOOP
	
{
my $abt_hl = ' bgcolor=#ffBB66';
my $marr_hl = ' bgcolor=#ffBBff';
my $emig_hl = ' bgcolor=#66ff66';


sub pr{
	($item,$extras) = @_;
	if ($item =~ /^\s*$/) {return('<td></td>')};
	if ($extras) {
		$tdx = "<td $extras>";
	} else {
		$tdx = '<td>';
	}
	$tdx =~ s/\s+/ /;
	return ("$tdx<font size=1>$item</td>");
}

sub page_data {
	&new_section;
	$comment=0;
	while (<>) {

		## NEW LINE

		chomp;
		s/</&lt;/;
		s/>/&gt;/;
		($child,$day,$month,$year,$note,$father,$mother,
			$place,$parish,$county,$chapman,$batch,$lds) = split(/:/);

		## COMMENTS	

		if ($child=~ /^#/) {		
			if ($comment eq 0) {
				print {$OUTFILE} "<tr><td><font size=1>$_</td></tr>\n";
				$comment=1;		
				next;
			} else {
				&end_section;
				&section_callback($child);
				&new_section;
				$comment=0;
				$first_line=1;
				next;
			}
		} else {
			$comment=0;
		}

		## HIGHLIGHTING

		$cbg='';$dbg='';$fbg='';$mbg='';$abg='';

		($ch_sname,$ch_fname) = names(FULLNAME => $child,SEX => MF);
		if (  (($month=~/Abt/) || ($month=~/^$/)) 
		   && (  ($batch=~/^$/)
		      || (($batch=~/CEN/) && ($ch_sname ne 'HEALD'))
			  )
		   )
			  {$abg=$abt_hl};

		$cbg = $dbg = $Sbg = (($batch) ? '': $abt_hl);

		if ($child=~/^m\./) {
			$dbg=$marr_hl;
			($fa_sname,$fa_fname) = names(FULLNAME => $father,SEX => M);
			($mo_sname,$mo_fname) = names(FULLNAME => $mother,SEX => F);
			if ($fa_sname eq 'HEALD') {
				$fbg=$marr_hl;
				if (($mo_sname eq 'HEALD') && ($batch)) {
					$mbg=$marr_hl;
				}
			} else {
				if ($mo_sname eq 'HEALD') {
					$mbg=$marr_hl;
				}
			}
		} 

		if ($child=~/EMIGRATED/) {
			$Sbg = $cbg=$dbg=$mbg=$fbg=$emig_hl;
		}

		$bold{'ch'} = '';$bold{'fa'} = '';$bold{'mo'} = '';
		if ($break_by eq 'ch') {
			($sname,$fname) = names(FULLNAME => $child,SEX => MF);
		} elsif ($break_by eq 'mo') {
			($sname,$fname) = names(FULLNAME => $mother,SEX => F);
		} elsif ($break_by eq 'fa') {
			($sname,$fname) = names(FULLNAME => $father,SEX => M);
		}
		
		if ($break_by) {
			if ($fname ne $prev_fname) {
				$bold{$break_by} = '<b>';
				if (!$first_line) {print {$OUTFILE} "<tr><td><font size=1>#</td></tr>\n"};
			}
			$prev_fname = $fname;
		}

		## LINKS

		if ($links_out) {
			$link_url = &link_url;
			$out_link="<a href=$outdir$link_url>LINK</a>";
		}
		if ($links_in) {
			$hc	= &hashcode;
			$in_link ="<a name=$hc>";
			$tr_id   =" id='tr#$hc'";
		}

		## ANCESTRAL FILE 
		
		(undef,$afn,$recid) = $lds =~ /(AF)\s*(\w*-\w*)\s*\((\d*)\)/;
		while ($afn) {
			$af_link = 'AFN:<a href="http://www.familysearch.org/Eng/Search/af/individual_record.asp?recid='.$recid.'">'.$afn.'</a>; ';
			$lds =~ s/(AF)\s*(\w*-\w*)\s*\((\d*)\)//;
			$lds = $af_link.$lds;
			(undef,$afn,$recid) = $lds =~ /(AF)\s*(\w*-\w*)\s*\((\d*)\)/;
		}

		## ROOTSWEB WORLDCONNECT 
		
		($wcdb,$wcid) = $lds =~ /WCN (\w*) (\d*)/;
		if ($wcdb =~ /^\d+$/) {$wcdb = ":$wcdb"};
		while ($wcdb) {
			$wclink = '<a href="http://worldconnect.rootsweb.com/cgi-bin/igm.cgi?op=GET&db='.$wcdb .'&id=I'.$wcid.'">'.$wcdb.'</a>';
			$lds =~ s/WCN (\w*) (\d*)/WCN $wclink/;
			($wcdb,$wcid) = $lds =~ /WCN (\w*) (\d*)/;
		}

		## FREE BMD
		
		my $done_gro_death = 0;

		(undef,undef,$gro_vol,$gro_page) = $note =~ /(GRO)\s+(\([\w\s]*\))?(\d\w*)\s+(\d\w*)/;
		if ($gro_vol) {
			$gro_type = 'Deaths';
			if ($note =~ /^\(d\. Q(\d) (\d\d\d\d)/) {
				$gro_q = $1;
				$gro_yr = $2;
			} elsif ($note =~ /^\(d\. \d*\s*(\w\w\w) (\d\d\d\d)/) {
				$gro_yr = $2;
				$gro_q = $quarter{$1};
			}
			# $gro_link = '<a href="http://www.freebmd.org.uk/cgi/search.pl?vol='.$gro_vol .'&pgno='.$gro_page .'&type='. $gro_type . '&start='.$gro_yr .'&sq='.$gro_q .'&end='.$gro_yr .'&eq='. $gro_q .'&action=Find">'.$gro_page .'</a>';
			$gro_link = '<a href="http://www.freebmd.org.uk/cgi/search.pl?vol='.$gro_vol .'&pgno='.$gro_page .'&type='. $gro_type . '&start='.$gro_yr .'&sq='.$gro_q .'&end='.$gro_yr .'&eq='. $gro_q .'">'.$gro_page .'</a>';
			$note =~ s/(GRO)\s+(\d\w*)\s+(\d\w*)/GRO $gro_vol $gro_link/;
			$done_gro_death = 1;
		}

		(undef,undef,$gro_vol,$gro_page) = $lds =~ /(GRO)\s+(\([\w\s]*\))?(\d\w*)\s+(\d\w*)/;
		if ($gro_vol) {
			if ($month =~ /Q/) {
				$gro_q = $month;
			} else {
				$gro_q = $quarter{$month};
			}
			$gro_q =~ s/Q//;
			$gro_yr = $year;
			if ($child =~ /^m\.$/) {
				$gro_type = 'Marriages';
			} elsif ((!$done_gro_death) && ($note =~ /^\(d\. Q(\d) (\d\d\d\d)/)) {
				$gro_type = 'Deaths';
				$gro_q = $1;
				$gro_yr = $2;
			} else {
				$gro_type = 'Births';
			} 
			# $gro_link = '<a href="http://www.freebmd.org.uk/cgi/search.pl?vol='.$gro_vol .'&pgno='.$gro_page .'&type='. $gro_type . '&start='.$gro_yr .'&sq='.$gro_q .'&end='.$gro_yr .'&eq='. $gro_q .'&action=Find">'.$gro_page .'</a>';
			$gro_link = '<a href="http://www.freebmd.org.uk/cgi/search.pl?vol='.$gro_vol .'&pgno='.$gro_page .'&type='. $gro_type . '&start='.$gro_yr .'&sq='.$gro_q .'&end='.$gro_yr .'&eq='. $gro_q .'">'.$gro_page .'</a>';
			$lds =~ s/(GRO)\s+(\d\w*)\s+(\d\w*)/GRO $gro_vol $gro_link/;
		    ##(undef,$gro_vol,$gro_page) = $lds =~ /(GRO)\s*(\d\w*)\s*(\d\w*)/;
		}
		
		## LIVING DESCENDENTS
		
		($desc,undef) = $lds =~ /REL ((\w+(\, )?)+)/;
		if ($desc) {
			#print "Found: $desc\n";
			@desc = split(/\, /,$desc);
			$desclink='';
			foreach $desc (@desc) {
				$desclink .= '<a href="../researchers.html#'.$desc.'">'.$desccode{$desc}.'</a> ';
			}
			$lds =~ s/REL ((\w+(\, )?)+)/REL $desclink/;
			#print "Link: $desclink\n";
		}
			
		## INTERNAL REFERENCES
		
		($ref_int,undef) = $lds =~ /\*(\w*)/;
		while ($ref_int) {
			(($refyear,undef,$refct,undef) = $ref_int =~ /(\d\d\d\d(_\d\d)?)([A-Z]{3})(_\d\d\d\d*)?$/) || last;
			$refyear =~ s/_/-/;
			$reffile = &get_filename($refct,$refyear);
			($refbef,undef) = $ref_int =~ /(Bef)/;
			if ($refct eq $chapman) {$reftext = "$refbef $refyear"} else {$reftext = "$refct, $refbef $refyear"};
			$reflink = "<a href='$outdir$reffile#$ref_int'>$reftext</a>";
			$lds =~ s/\*\w*/$reflink/;
			($ref_int,undef) = $lds =~ /\*(\w*)/;
		}
		($ref_int,undef) = $note =~ /\*(\w*)/;
		while ($ref_int) {
			(($refyear,undef,$refct,undef) = $ref_int =~ /(\d\d\d\d(_\d\d)?)([A-Z]{3})(_\d\d\d\d*)?$/) || last;
			$refyear =~ s/_/-/;
			$reffile = &get_filename($refct,$refyear);
			($refbef,undef) = $ref_int =~ /(Bef)/;
			if ($refct eq $chapman) {$reftext = "$refbef $refyear"} else {$reftext = "$refct, $refbef $refyear"};
			$reflink = "<a href='$outdir$reffile#$ref_int'>$reftext</a>";
			$note =~ s/\*\w*/$reflink/;
			($ref_int,undef) = $note =~ /\*(\w*)/;
		}
		
		## CENSUS LINKS
		
		my $incl_ref=0;
		#$cen_link='';
		while (1) {
			if ($lds =~ /\-\-\-> CEN 1901/)  {$out_link='LINK'};
			$post_text='';
			if ($lds =~ s/CEN 1901 (\w*) (\([^\)]*\))/QQQQQ/) {
				$cen_year = 1901;$cen_ref=$1;$post_text=" $2";
			} elsif ($lds =~ s/CEN 1881 (\w*) (\([^\)]*\))/QQQQQ/) {
				$cen_year = 1881;$cen_ref=$1;$post_text=" $2";
			} elsif ($lds =~ s/CEN 1851 (\w*) (\([^\)]*\))/QQQQQ/) {
				$cen_year = 1851;$cen_ref=$1;$post_text=" $2";
			} elsif ($lds =~ s/CEN (\d\d\d\d) (\(([^\)]*)\))/QQQQQ/) {
				$cen_year = $1;$post_text=" $2";$cen_ref=$3;
			} elsif ($lds =~ s/CEN (\d\d\d\d) (\w*)/QQQQQ/) {
				$cen_year = $1;$cen_ref=$2;
			} else {
				last;
			}
			$cen_text = $cen_year;
			$cen_ref =~ s/, \w\w\w$//;
			$cen_ref =~ s/\s+/_/g;
			$cen_ref =~ s/,//g;
			$cen_url = &cen_url($cen_year,$cen_ref);
			$cen_link = "CEN <a href='$outdir$cen_url'>$cen_text</a>$post_text";
			$lds =~ s/QQQQQ/$cen_link/;
		}
		
		## WILLS
		
		$wills_page = "<a href='$outdir../wills2.html";
		$lds =~ s/(WILL|ADM|EXOR) (\w\w(\d\d\d\d)\w\w\w)/$1 $wills_page#$2'>$3<\/a>/g;
		
		## MISC BMD
		
		$lds =~	s/MISC (\w\w\w)$/MISC <a href=\"$outdir..\/misc_bmd.html#$1\">$1<\/a>/;
		$lds =~	s/MISC (\w\w\w) /MISC <a href=\"$outdir..\/misc_bmd.html#$1\">$1<\/a> /;

		## PARISH REGISTERS

		if (($lds =~	/(PR|LIC) ([^<\s]*)/) && ($2 ne 'xxx')) {
			$p_reg_link = $2;
			($p_reg_type = $p_reg_link) =~ s/_(.*)$//;
			$p_reg_chap = lc(substr($p_reg_link,-3));
			if ($p_reg_file{$p_reg_chap}) {
				$p_reg_file = $p_reg_file{$p_reg_chap};
			} else {
				$p_reg_file = 'misc';
			}
			$lds =~	s/(PR|LIC) [^<\s]*/$1 <a href=\"$outdir..\/registers\/$p_reg_file.html#$p_reg_link">$p_reg_type<\/a>/;
		}

		if (($note =~	/(PR|LIC) ([^<\s]*)/) && ($2 ne 'xxx')) {
			$p_reg_link = $2;
		        if ($p_reg_link =~ s/(\))?$//) {
		        	$lastch = $1;
		        } else {
		        	$lastch = '';
		        }
		        
			($p_reg_type = $p_reg_link) =~ s/_(.*)$//;
			$p_reg_chap = lc(substr($p_reg_link,-3));
			if ($p_reg_file{$p_reg_chap}) {
				$p_reg_file = $p_reg_file{$p_reg_chap};
			} else {
				$p_reg_file = 'misc';
			}
			$note =~ s/(PR|LIC) [^<\s]*/$1 <a href=\"$outdir..\/registers\/$p_reg_file.html#$p_reg_link">$p_reg_type<\/a>/;			
			$note .= $lastch;
		}

		$lds =~	s/INDX pallot/INDX <a href=\"$outdir..\/registers\/pallot.html">pallot<\/a>/;
		
		## INCE'S PEDIGREES
		
		$lds =~ s/INCE (\d\d\d\.htm) (\d\d\d\w)/INCE <a href=\"http:\/\/www.wirksworth.org.uk\/INC-$1#$2\">$2<\/a>/;
		
		
		## TRADE DIRECTORIES 
		
		($tr_text,$tr_code,undef) = $lds =~ /TRA (\D*) \s*(\w*\d\d\d\d\w\w\w)/;
		if ($tr_code) {
			($tr_yr,$tr_ch) = $tr_code =~ /(\d\d\d\d)(\w\w\w)$/;
			if ($tr_ch ne $chapman) {
				$tr_link = "<a href='$outdir../trades.html#$tr_code'>$tr_ch, $tr_yr</a>";
			} else {
				$tr_link = "<a href='$outdir../trades.html#$tr_code'>$tr_yr</a>";
			}
			$lds =~ s/TRA (\D*) (\w*\d\d\d\d\w\w\w)/TR $tr_text $tr_link/;
		}
			
		
		## ALUMNI
		
		(undef,$univ,$matric) = $lds =~ /(Univ|UNIV)\.?\s*(Cam|Ox),?\s*(\d\d\d\d)/;
		if ($univ) {
			if ($child =~ /m\./) {
				$unm = substr($father,0,2);
			} else {
				$unm = substr($child,0,2);
			}
			$uhc = "$unm$matric".lc($univ);
			$ulink = "UNIV <a href='$outdir../alumni.html#$uhc'>$univ $matric</a>";
			$lds =~ s/(Univ|UNIV)\.?\s*(Cam|Ox),?\s*(\d\d\d\d)/$ulink/;
		}

		## TEXT RE-PROCESSING

		$tbatch = substr($batch,0,7);
		$tbatch =~ s/s*$//;
		($tbatch2 = $tbatch) =~ s/CEN//;
		$tplace = substr($place,0,36);

		if ($day eq '') {$day='&nbsp;'};  # so empty cell gets highlighted
		if ($month eq '') {$month='&nbsp;'};

		## FORCE WIDTHS OF FIELDS

		if ($first_line) {
		#	$wid=' width=15%';$widb=' width=5%';$widp=' width=9%';
		#	$widl=' width=3%';$widn = ' width=20%';
			$widn = ' width=24%';
		} else {
			$wid='';$widb='';$widp='';$widl='';$widn='';
		}

		## OUTPUT
		
		$pr{'C'}	= pr("$bold{'ch'}$in_link$child","$wid$cbg");
		$pr{'d'}	= pr($day,$dbg);
		$pr{'m'}	= pr($month,$dbg);
		$pr{'y'}	= pr($year,$dbg);
		$pr{'b'}	= pr($tbatch,$widb);
		$pr{'F'} 	= pr("$bold{'fa'}$father","$wid$fbg");
		$pr{'M'} 	= pr("$bold{'mo'}$mother","$wid$mbg");
		$pr{'p'} 	= pr($tplace,$widp);
		$pr{'t'} 	= pr($parish);
		$pr{'c'} 	= pr($chapman);
		$pr{'l'}	= pr($out_link,$widl);
		$pr{'-'}	= pr('&nbsp;');
		$pr{'_'}	= pr('&nbsp;',$cbg);
		
		if ($field_list =~ /Z/) {
			if ($father || $mother) {
				$pr{'Z'} = "$pr{'F'}$pr{'M'}";
			} else {
				$pr{'Z'} = "<td$abg colspan=2><font size=1>- $note</td>";
				$note = '';
			}
		}
		
		$pr{'N'} 	= pr("$note $lds","$Sbg$widn");
		
		if ($tplace) {
	    	$pr{'Q'}	= pr("$parish, $tplace");
		} else {
			$pr{'Q'}	= pr("$parish");
		}
		
		($tp1 = $tplace) =~ s/^\s*((<|&lt;)?[Oo]f)?\s*$//i;
		if ($tp1) {
			$txt = "$parish, $tplace";
			$txt =~ s/(>|&gt;), (<|&lt;)/, /;
	    	$pr{'R'}	= pr("$txt");
		} else {
			$pr{'R'}	= pr("$parish");
		}

		if ($tplace =~ /^Of \[?([\w\s]*)/) {
			$pr{'P'} = pr("$parish, $1");
		} else {
			$pr{'P'} = pr($parish);
		}
		
		if ($tbatch2 && ($lds || $note)) {
			$pr{'S'} = pr("$tbatch2; $note $lds","$Sbg$widn");
		} else {
			$pr{'S'} = pr("$tbatch2$note $lds","$Sbg$widn");
		}
		
		print {$OUTFILE} "<tr$tr_id>";
		foreach $field (split(//,$field_list)) {
			print {$OUTFILE} "$pr{$field}";
		}
		print {$OUTFILE} "</tr>\n";
		$first_line = 0;
		$section_linecount++;
	}

	&end_section;
}
}
# cat file.dat | perl pretty.pl | a2ps --columns=1 -l180 -Plaser


