#!/usr/local/bin/perl 

#$| = 1;

#require '../code/heald_lib.pl';
require 'heald_output_lib.pl';

## OPTIONS PROCESSING

use Getopt::Std;

getopts(':MF');

die "must have -[M|F] DATE\n" unless ($opt_M || $opt_F);

if ($opt_F) {$sex='F'};
if ($opt_M) {$sex='M'};
$date = shift;

%date_file = (
	1625 => 1,
	1725 => 2,
	1800 => 3,
	1850 => 4,
	1900 => 5,
);

%file_date = (
	1 => 1625,
	2 => 1725,
	3 => 1800,
	4 => 1850,
	5 => 1900,
);

die "Bad DATE: DATE must be one of 1625, 1725, 1800, 1850, 1900\n"
		unless ($date_file{$date});

$earlier_fname = '';
$later_fname = '';
$earlier_file = $date_file{$date} - 1;
$this_file = $date_file{$date};
$later_file = $date_file{$date} + 1;
if ($later_file == 6) {$later_file=0};
if ($earlier_file) {
	$earlier_fname = "children_$sex$file_date{$earlier_file}.html";
}
if ($later_file) {
	$later_fname = "children_$sex$file_date{$later_file}.html";
}

%descMF = (
	m => 'Male',
	f => 'Female',
);	

%descdate = (
	1625 => 'pre 1625',
	1725 => '1626-1725',
	1800 => '1726-1800',
	1850 => '1801-1850',
	1900 => '1851-1900',
	C19	 => '1801 onwards',
);

$title = "Heald Children UK: $descMF{$sex}, $descdate{$date}";


## OUTPUT

sub section_callback {
	my ($text,undef) = @_;
	if ($section_linecount > 20) {
		print {$OUTFILE} "</table>\n";
		print {$OUTFILE} "<table border=0 cellspacing=0 width=100%>";
		print {$OUTFILE} "<font class=f2unbold face='times'>\n";
	}
	&section_head($text,'itELCh');
	if ($section_linecount > 20) {
		print {$OUTFILE} "</table>\n";
		print {$OUTFILE} "<table border=0 cellspacing=0 width=100%>";
		print {$OUTFILE} "<font class=f2unbold face='times'>\n";
		$section_linecount = 0;
	}
}

$OUTFILE = *STDOUT;
$links_out = 1;
$do_az_bar = 1;
$break_by	= 'ch';
$field_list = 'CdmycPZlS';
&page_header($title,'','iCh');
&page_data;
&page_footer('itCh');

__END__



