#!/usr/local/bin/perl 

#$| = 1;

#require '../code/heald_lib.pl';
require 'heald_output_lib.pl';
use IO::File;

## OPTIONS PROCESSING

use Getopt::Std;

getopts(':BMF');

die "must have -[M|F] DATE\n" unless ($opt_M || $opt_F);

if ($opt_F) {$sex='F'};
if ($opt_M) {$sex='M'};
$date = shift;

%date_file = (
	1625 => 1,
	1725 => 2,
	1800 => 3,
	1850 => 4,
	1900 => 5,
);

%file_date = (
	1 => 1625,
	2 => 1725,
	3 => 1800,
	4 => 1850,
	5 => 1900,
);

die "Bad DATE: DATE must be one of 1625, 1725, 1800, 1850, 1900\n"
		unless ($date_file{$date});

$OUTDIR = 'output/ch/';
if ($opt_B) {
	$outdir = 'http://www.jpm1.freeserve.co.uk/heald_uk/bm/';  # relative location of data pages from index pages
} else {
	$outdir = '../';
}
$file_prefix = "ch_$sex$date";

$earlier_file_prefix = '';
$later_file_prefix = '';
$earlier_file = $date_file{$date} - 1;
$this_file = $date_file{$date};
$later_file = $date_file{$date} + 1;
if ($later_file == 6) {$later_file=0};
if ($earlier_file) {
	$earlier_file_prefix = "ch_$sex$file_date{$earlier_file}";
}
if ($later_file) {
	$later_file_prefix = "ch_$sex$file_date{$later_file}";
}

%descMF = (
	M => 'Male',
	F => 'Female',
);	

%descdate = (
	1625 => 'pre 1625',
	1725 => '1626-1725',
	1800 => '1726-1800',
	1850 => '1801-1850',
	1900 => '1851-1900',
	C19	 => '1801 onwards',
);

$title = "Heald Children UK: $descMF{$sex}, $descdate{$date}";

$earlier_link='';
$later_link='';
sub empty_pages {
	@alphabet = split(//,'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
	push(@alphabet,'Ukn');
	foreach $letter (@alphabet) {
		next if ($seen{$letter});
		if ($earlier_file) {
			$earlier_link = "$earlier_file_prefix$letter.html";
		}
		if ($later_file) {
			$later_link = "$later_file_prefix$letter.html";
		}
		$OUTFILE = IO::File->new("> $OUTDIR$file_prefix$letter.html");
		&page_header($title,'','iCh');
		&az_bar2;
		&section_head($text,'itelCh');
		print $OUTFILE "<tr><td colspan=20><center>$letter: none found<br><br><br></center></td></tr>";
		&az_bar2;
		&page_footer('itelCh');
		close($OUTFILE);
	}
}

## OUTPUT

sub section_callback {
	my ($text,undef) = @_;
	$sec_name = '';
	($sec_name,undef) = $text=~ /^#\W*(\w)/;
	if ($text=~ /(\=END\=)/) {$sec_name=$1};
	
	$sec_name ||= 'Ukn';
	
	if ($OUTFILE) {
		print $OUTFILE "<tr><td colspan=20><table width=100%><tr>\n";
		&rlinks('itelCh');
		print $OUTFILE "</tr></table><br></td></tr>\n";
		&az_bar2;
		&page_footer('itCh');
		close($OUTFILE);
	}
	
	return if ($sec_name =~ /=END=/);  # last one

	#print "--$sec_name--\n";
	if ($earlier_file) {
		$earlier_link = "$earlier_file_prefix$sec_name.html";
	}
	if ($later_file) {
		$later_link = "$later_file_prefix$sec_name.html";
	}
	
	$OUTFILE = IO::File->new("> $OUTDIR$file_prefix$sec_name.html");
	#if ($opt_B) {
	#print $OUTFILE "<BASE HREF='http://www.jpm1.freeserve.co.uk/heald_uk/bm/'>\n";
	#};
	$seen{$sec_name}=1;
	&page_header($title,'','iCh');
	&az_bar2;
	&section_head($text,'itelCh');
}

$tmp = 'temp';
$OUTFILE = IO::File->new("> $OUTDIR$tmp.html");
#if ($opt_B) {
#	print $OUTFILE "<BASE HREF='http://www.jpm1.freeserve.co.uk/heald_uk/bm/'>\n";
#};
$links_out = 1;
$do_az_bar = 0;
$break_by	= 'ch';
$field_list = 'CdmycPZlS';
&page_header($title,'','iCh');
&page_data;
#&page_footer('itelCh');
#close($OUTFILE);
&section_callback('=END='); # dummy argument to indicate last one
&empty_pages;

__END__



