require 'heald_output_lib.pl';
use IO::File;

use Getopt::Std;

getopts('e:',\%opt);

die "must have -e DATE\n" unless ($opt{'e'});

$date = $opt{'e'};

%date_file = (
	1625 => 1,
	1725 => 2,
	1800 => 3,
	1850 => 4,
	1900 => 5,
);

%file_date = (
	1 => 1625,
	2 => 1725,
	3 => 1800,
	4 => 1850,
	5 => 1900,
);

die "Bad DATE: DATE must be one of 1625, 1725, 1800, 1850, 1900\n"
		unless ($date_file{$date});

$earlier_link = '';
$later_link = '';
$earlier_file = $date_file{$date} - 1;
$this_file = $date_file{$date};
$later_file = $date_file{$date} + 1;
if ($later_file == 6) {$later_file=0};

open (AREAS,"dat/areas.dat")
	|| die ("Couldn't open file areas.dat\n");

$lnum=0;
while (<AREAS>) {

	chomp;
	$lnum++;
	@ar = split(/:/);

	if (/--(\w\w\w)--/) {
		$ct=$1;
		for ($col=1;$col<=5;$col++) {
			$this_area{$col} = lc($ct);
		}
	}
		
	
	for ($col=1;$col<=5;$col++) {
		#print "\t == $ar[$col-1]";
		if ($ar[$col-1] =~ /^\s*(\w+)/) {
			$ar1 = lc($1);
			$this_area{$col} = ($ar1);
			$line[$col]->{$ar1} = $lnum;
		}
			
		$area[$col]->{$lnum} = $this_area{$col};
		#print "\t -- $this_area{$col}";
		#print ("$col:$ar1 -> $line[$col]->{$ar1}\n");
	}
	#print "\n";
}

$OUTDIR = 'output/';
$outdir = '';

%postfix = (
	LAN => "_LAN",
	CHS => "_CHS",
	YKS => "_YKS",
	DBY => "_DNL",
	NTT => "_DNL",
	LIN => "_DNL",
	def => "e$date",
);


%ofile = (
	LAN => "e$date"."_LAN",
	CHS => "e$date"."_CHS",
	YKS => "e$date"."_YKS",
	DBY => "e$date"."_DNL",
	NTT => "e$date"."_DNL",
	LIN => "e$date"."_DNL",
	def => "e$date",
);

%descfile = (
	LAN => 'LAN,',
	CHS => 'CHS,',
	YKS => 'YKS,',
	DBY => "DBY NTT & LIN,",
	NTT => "DBY NTT & LIN,",
	LIN => "DBY NTT & LIN,",
	def => "",
);

%descdate = (
	1625 => 'pre 1625',
	1725 => '1626-1725',
	1800 => '1726-1800',
	1850 => '1801-1850',
	1900 => '1851-1900',
	C19	 => '1801 onwards',
);

read_hash(FILENAME => 'dat/counties.dat', HASH => \%chapman, 
			FIRSTKEY => 2, CASE => 'U');
	

$latest_ofile = $ofile{'def'};

sub section_callback {
	my ($text,undef) = @_;
	$section_linecount{$latest_ofile} = $section_linecount;
	($ct_name,undef) = $text=~ /^#\s*([\w]*)/;
	$ct = $chapman{std($ct_name,'U')};
	if ($ct) {
		$prev_ct = $this_ct;
		$this_ct = $ct;
		$earlier_anchor = ($this_ct);
		$later_anchor = ($this_ct);
	} else {
		$prev_area = $this_area;
		($this_area,undef) = $text=~ /^#\s*-*\s*([\w]*)/;
		$this_area = lc($this_area);
		$l = $line[$this_file]->{$this_area};
		#print "$this_area -> $l\n";
		$earlier_anchor = $area[$earlier_file]->{$line[$this_file]->{$this_area}};
		$later_anchor = $area[$later_file]->{$line[$this_file]->{$this_area}};
	}
	if ($ct && $ofile{$ct}) {
		$OUTFILE=$fh{$ofile{'def'}};
		if ($earlier_file) {
			$earlier_link = 'e'.$file_date{$earlier_file}.'.html#'.$earlier_anchor;
		}
		if ($later_file) {
			$later_link = 'e'.$file_date{$later_file}.'.html#'.$later_anchor;
		}
		&section_head($text,'iteluh',$ct,$earlier_link,$later_link);
		&new_section;
		print $OUTFILE "<tr><td><font size= -1>#</td></tr>";
		print $OUTFILE "<tr><td colspan=13><font size= -1><dd>See <a href='$ofile{$ct}.html#$ct'>$ofile{$ct}.html#$ct</a></dd></td></tr>\n";
		print $OUTFILE "<tr><td><font size= -1>#</td></tr>";
		&end_section;
	}
	if ($ct) {
		$latest_ofile = $ofile{$ct}||$ofile{'def'};
		$OUTFILE = $fh{$latest_ofile};
	}	
	$section_linecount = $section_linecount{$latest_ofile};
	if ($section_linecount > 20) {
		print {$OUTFILE} "</table>\n";
		print {$OUTFILE} "<table border=0 cellspacing=0 width=100%>";
		print {$OUTFILE} "<font class=f2unbold face='times'>\n";
	}
	if ($earlier_file) {
		$earlier_link = 'e'.$file_date{$earlier_file}.$postfix{$this_ct}.'.html#'.$earlier_anchor;
	}
	if ($later_file) {
		$later_link = 'e'.$file_date{$later_file}.$postfix{$this_ct}.'.html#'.$later_anchor;
	}
	if (!$ct) {
		print {$OUTFILE} "<a name='$this_area'>\n";
	}
	&section_head($text,'iteluh',$ct,$earlier_link,$later_link);
	if ($section_linecount > 20) {
		print {$OUTFILE} "</table>\n";
		print {$OUTFILE} "<table border=0 cellspacing=0 width=100%>";
		print {$OUTFILE} "<font class=f2unbold face='times'>\n";
		$section_linecount = 0;
	}
}

## FLAGS 
$links_in = 1;
#$field_list = 'CdmybFMptcN';
#$field_list = 'CdmyFMptcS';
$field_list = 'CdmybZRcN';


## OPEN FILES

foreach $ct (keys %ofile) {
	$f = $ofile{$ct};
	next if ($open{$f});
	$fh{$f} = IO::File->new("> $OUTDIR$f.html");
	$OUTFILE = $fh{$f};
	&page_header("Heald Births and Marriages UK: 
				$descfile{$ct} $descdate{$date}",'','iuh');
	$open{$f} = 1;
}


## PRINT PAGES

&page_data;


## CLOSE FILES

foreach $f (keys %open) {
	$OUTFILE = $fh{$f};
	&page_footer('ituh');
}
