#!/usr/local/bin/perl 

#$| = 1;

#require '../code/heald_lib.pl';
require 'heald_output_lib.pl';
use IO::File;

## OPTIONS PROCESSING

use Getopt::Std;

getopts(':ABHW12345');

if ($opt_H) {$act='H'};
if ($opt_W) {$act='W'};
if ($opt_A) {$act='A'};
die "action not recognised\n" unless ($opt_H || $opt_W || $opt_A);

if ($opt_1) {$list=1};
if ($opt_2) {$list=2};
if ($opt_3) {$list=3};
if ($opt_4) {$list=4};
if ($opt_5) {$list=5};
die "list type not recognised\n" unless ($list);

$al = "$act$list";


%title = (
	H1 => 'Husbands of UK Healds, Wife Firstname Index',
	H2 => 'Husbands of UK Healds, Joint Furstname Index',
	H3 => 'Husbands of UK Healds, Husband Firstname Index',
	H4 => 'Husbands of UK Healds, Husband Surname Index',
	H5 => 'Husbands of UK Healds, Semialphabetical Husband Surname Index',
	W1 => 'Wives of UK Healds, Husband Firstname Index',
	W2 => 'Wives of UK Healds, Joint Firstname Index',
	W3 => 'Wives of UK Healds, Wife Firstname Index',
	W4 => 'Wives of UK Healds, Wife Surname Index',
	W5 => 'Wives of UK Healds, Semialphabetical Wife Surname Index',
	A1 => 'Spouses of UK Healds, A-Z by Surname',

);

%desc = (
	H1 => "Husbands of UK Healds, arranged by wife's first name",
	H2 => "Husbands of UK Healds, arranged by her first name then his",
	H3 => "Husbands of UK Healds, arranged by husband's first name",
	H4 => "Husbands of UK Healds, arranged by husband's surname",
	H5 => "Husbands of UK Healds, arranged by first letter of husband's surname",
	W1 => "Wives of UK Healds, arranged by husband's first name",
	W2 => "Wives of UK Healds, arranged by his first name then hers",
	W3 => "Wives of UK Healds, arranged by wife's first name",
	W4 => "Wives of UK Healds, arranged by wife's surname",
	W5 => "Wives of UK Healds, arranged by first letter of wife's surname",
	A1 => 'Spouses of UK Healds, A-Z by Surname',
);

%breaks = (
	H1 => mo,
	H2 => mo,
	H3 => fa,
	W1 => fa,
	W2 => fa,
	W3 => mo,
);

$OUTDIR = 'output/marr/';
if ($opt_B) {
	$outdir = 'http://www.jpm1.freeserve.co.uk/heald_uk/bm/';  # relative location of data pages from index pages
} else {
	$outdir = '../';
}
$file_prefix = lc($al);

sub empty_pages {
	@alphabet = split(//,'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
	foreach $letter (@alphabet) {
		next if ($seen{$letter});
		$OUTFILE = IO::File->new("> $OUTDIR$file_prefix$letter.html");
		&page_header($title{$al},$desc{$al},'imh');
		&az_bar2;
		&section_head($text,'itmh');
		print $OUTFILE "<tr><td colspan=20><center>$letter: none found<br><br><br></center></td></tr>";
		&az_bar2;
		&page_footer('itmh');
		close($OUTFILE);
	}
}



sub section_callback {
	my ($text,undef) = @_;
	($sec_name,undef) = $text=~ /^#\W*(\w)/;
	
	$sec_name ||= 'Ukn';
	
	if ($OUTFILE) {
		&az_bar2;
		&page_footer('itmh');
		close($OUTFILE);
	}
	
	#print "--$sec_name--\n";
	$OUTFILE = IO::File->new("> $OUTDIR$file_prefix$sec_name.html");
	#if ($opt_B) {
	#	print $OUTFILE "<BASE HREF='http://www.jpm1.freeserve.co.uk/heald_uk/bm/'>\n";
	#};
	$seen{$sec_name}=1;
	&page_header($title{$al},$desc{$al},'imh');
	&az_bar2;
	&section_head($text,'itmh');
}

$tmp = 'temp';
$OUTFILE = IO::File->new("> $OUTDIR$tmp.html");
#if ($opt_B) {
#	print $OUTFILE "<BASE HREF='http://www.jpm1.freeserve.co.uk/heald_uk/bm/'>\n";
#};
$links_out = 1;
$do_az_bar = 0;
$do_cbold	= 0;
#$field_list = 'CdmybFMcQlN';
$field_list = 'CdmyFMcQlS';
$break_by = $breaks{$al};
&page_header($title{$al},$desc{$al},'imh');
&page_data;
&page_footer('itmh');
close($OUTFILE);
&empty_pages;

__END__

 
