$ct=1;

require '../code/heald_lib.pl';

&read_counties;

@hashlist = \(%year,%surname,%forenames,%address,%chapman,%occ,
		%formerly,%date_died,%place_died,%documents,
		%value,%probate_office,%date_proved,%execs);

while (<>) {
	s/""/_DQUOTE_/g;
	s/"//g;
	s/_DQUOTE_/"/g;
	next if (/^\s*#/);	

	$ct++;
	($year,$surname,$forenames,$address,$chapman,$occ,
		$formerly,$date_died,$place_died,$documents,
		$value,$probate_office,$date_proved,$execs) = @line = split(/\t/);

	foreach $rhash (@hashlist) {
		$rhash->{$ct} = shift(@line);
	}
}

sub by_ordering {
	by_county() || ($a<=>$b);
}

sub by_sequence {
	($a<=>$b);
}

sub wills_page_header {
	
	print << 'End_of_Wills_Header';
<HTML>
<HEAD>
<TITLE>Heald Probate and Wills UK, after 1858</TITLE>
</HEAD>
<BODY BGCOLOR=#FFFFFF>
<table width=100% border=0><tr><td><font face="arial" size=5><b>HEALD UK</b></font></td>
<td align=right><font class=f2unbold face="arial,helvetica,sans serif" size=2>
<a href='index.html'>HOME</a>
</td></tr></table>
<HR color=#CC0000>
</font>
<font face="arial" size=-1>
<B>Heald Probate and Wills UK, after 1858</B>
</font>
<BR><BR>
<table width=580 cellspacing=0 cellpadding=0><tr><td>
<font face="verdana, arial, helvetica" size="-1">
This page: wills proved from 1858-1881
<UL>
<LI>
<a href='#LAN'>LAN</a>;
<a href='#CHS'>CHS</a>;
<a href='#NBL'>NBL</a>;
<a href='#YKS'>YKS</a>;
<a href='#DBY'>DBY</a>;
<a href='#NTT'>NTT</a>;
<a href='#LIN'>LIN</a>;
<a href='#STS'>STS</a>;
<a href='#CAM'>CAM</a>;
<a href='#NFK'>NFK</a>;
<a href='#SRY'>SRY</a>;
<a href='#KEN'>KEN</a>;
<a href='#LND'>LND</a>;
<a href='#MDX'>MDX</a>
</ul>
<p>See also:
<a href="wills.html">Wills before 1858</a>
</font>

<br><br><br>
<i>Source:</i> Extracted from the printed indexes of the national probate registry, on fiche.<br>
<p>
Note: not yet rechecked; some fields not always transcribed;
only the surname variants Heald/e/s are included;
further indexes from 1882 to present day not yet examined.
<p>
Adm. = Administration grant (no will)
</td></tr></table>

End_of_Wills_Header

}

sub wills_page_footer {
	print << 'End_of_Wills_Footer';
<p>
<table width=100% border=0><tr>
<td><font class=f2unbold face="arial,helvetica,sans serif" size=2>
<script>document.write("Last modified: ",document.lastModified,"<BR>")</script>
Feedback: <a href="mailto:j.heald@ucl.ac.uk">j.heald@ucl.ac.uk</a>
 </font></td>
<td align=right><font class=f2unbold face="arial,helvetica,sans serif" size=2>
<a href='#'>Top</a> / 
<a href='index.html'>HOME</a></td></tr></table>
</body></html>
End_of_Wills_Footer

}

sub new_county {

	print "<tr><td colspan=20>\n";
	print "<table width=100% border=0 cellspacing=0 cellpadding=0 cellvspacing=0><tr>";
	print "<td><br><a name='$chapman{$ct}'><h2>$county_name{$chapman{$ct}}</h2></td>";
	print "<td align=right><font class=f2unbold face='arial,helvetica,sans serif' size=2><a href='#'>Top</a> / <a href='index.html'>Home</a>";
	print "</td></tr></table></tr>\n";
	
	$last_chap = $chapman{$ct};

	print << 'End_of_Column_Descriptions';
<tr BGCOLOR="#AAFFFF">
<td colspan=2><font size= -1><b>Year</b></td>
<td><font size= -1><b>Name</b></td>
<td><font size= -1><b>Address</b></td>
<td><font size= -1><b>Date Died</b></td>
<td><font size= -1><b>Occupation</b></td>
<td><font size= -1><b>Value</b></td>
<td><font size= -1><b>Probate Office</b></td>
</tr>
End_of_Column_Descriptions

}


$last_chap = '';
&wills_page_header;
print "<table cellspacing=0>\n";
foreach $ct (sort by_ordering (keys(%year))) {
#foreach $ct (sort by_sequence (keys(%year))) {
	
	if ($chapman{$ct} ne $last_chap) {&new_county};
	print '<tr>';
	print "<td colspan=2><font size=-1>$year{$ct}:";
	if ($documents{$ct}) {print "$documents{$ct}"};
	print "\t</td>";
	print "<td><font size=-1>$surname{$ct}, $forenames{$ct}\t</td>";
	print "<td><font size=-1>$address{$ct}\t</td>";
	print "<td><font size=-1>d. $date_died{$ct} $place_died{$ct}\t</td>";
	print "<td><font size=-1>$occ{$ct}";
	if ($formerly{$ct}) {print " (formerly of $formerly{$ct})"};
	print "\t</td>";
	print "<td><font size=-1>";
	if ($value{$ct}) {
		if ($year{$ct} < 1882) {
			print "&lt; $value{$ct}";
		} else {
			print "$value{$ct}";
		}
	}
	print "\t</td>";
	print "<td><font size=-1>$probate_office{$ct}";
	if ($date_proved{$ct}) {print ", $date_proved{$ct}"};
	print "\t</td>";
	print "</tr>\n";
	
	@executors = split(/;/,$execs{$ct});
	foreach $exec (@executors) {
		print "<tr><td><font size=-1>\t</td><td colspan=20><font size=-1>exec: $exec</td></tr>\n";
	}
	print "<tr><td><font size=-1>&nbsp;\t</td></tr>\n";
}
print "</table>";
&wills_page_footer;
	
	