$stats_file = 'stats/summary.dat';
$tem_file = 'stats/counties_tem.html';


%file_base = (
	1 => "e1625",
	2 => "e1725",
	3 => "e1800",
	4 => "e1850",
	5 => "e1900",
);

%file_suf = (
	LAN => "_LAN",
	CHS => "_CHS",
	YKS => "_YKS",
	DBY => "_DNL",
	NTT => "_DNL",
	LIN => "_DNL",
);

sub find_link {
	my ($iter,$chap) = @_;
	$base_name = $file_base{$iter};
	$suffix    = $file_suf{$chap};
	return ('<a href=bm/'.$base_name.$suffix.".html#$chap>");
}


open(STATS_FILE,$stats_file)
	|| die ("Couldn't open $stats_file");
	
open(TEM_FILE,$tem_file)
	|| die ("Couldn't open $tem_file");

while (<STATS_FILE>) {
	chomp;
	($chap,$stats) = split(/:/);
	$chap =~ s/\s*//g;
	($detail,$total{$chap}) = split(/=/,$stats);
	@{$details{$chap}} = split(/\+/,$detail);
	$unused{$chap} = 1;
	#print("$chap : $total{$chap} ;\n");
}



while (<TEM_FILE>) {
	if (! /##DATA##/) {
		print;
		next;
	}
	($chap, undef) = /^<td><font size= -1>(\w\w\w|---)/;
	#print "\n---FOUND---  $chap\n\n";
	$data = '';
	$iter = 0;
	foreach $item (@{$details{$chap}}) {
		$item =~ s/\s*//g;
		$iter++;
		if ($item) {
			$link = find_link($iter,$chap);
			$item = $link.$item.'</a>';
		} else {
			$item='-';
		}
		$data .= '<td><font size= -1>'.$item.'</td>';
	}
	$item = $total{$chap};
	$item =~ s/\s*//g;
	$data .= '<td><font size= -1><b>'.$item.'</b></td>';
	
	s/##DATA##/$data/;
	print;
	$unused{$chap} = 0;
}
	
print "\n\n";
foreach $chap (keys %unused) {
	next unless ($chap);
	if ($unused{$chap}) {print "$chap\n"};
}

	